<!DOCTYPE html>

<h1>CFMobile Photo Demo App </h1>
This demo app shows how to take picture and upload to CF server using CFMobile features.<br>

<button  type="button" id="takePictBtn">Take Picture & Upload</button><br>
<button type="button" id="setServerURLBtn">Set Server URL</button>
<h2>Messages</h2>
<div id="msgDiv"></div>

<script >
	document.getElementById("setServerURLBtn").onclick = function(){
		var serverUrl = "";
		if (typeof localStorage.serverUrl !== "undefined")
			serverUrl = localStorage.serverUrl;
		serverUrl = prompt("Enter Server URL",serverUrl);
		if (serverUrl != null)
			localStorage.serverUrl = serverUrl;
	};
	
	document.getElementById("takePictBtn").onclick = function(){
		takePictureAndUpload();
	};
	
	function displayMessage (msg, append)
	{
		var divElm = document.getElementById("msgDiv");
		if (append != undefined && !append)
			divElm.innerHTML = "";
		divElm.innerHTML += msg;
	}
</script>


<cfclientsettings enabledeviceapi="true" >
<cfclient>
	<cfscript>
		function takePictureAndUpload()
		{
			var imageUrl = cfclient.camera.getPicture();
			
			if (!isDefined("imageUrl") || imageUrl.length == 0)
				return;
							
			displayMessage("Temporary image - " + imageUrl + "<br><hr>", false);
			
			//This file is in a temporary file system. Move it to persistent file system
			var newFilePath = copyFileFromTempToPersistentFileSystem(imageUrl);
			
			//Now upload file to the server
			uploadFileToServer(newFilePath);
			
			//Delete temporary file
			cfclient.file.remove(imageUrl);
			displayMessage("Deleted temporaty file " + imageUrl + "<br><hr>");
		}
		
		function copyFileFromTempToPersistentFileSystem (tempFilePath)
		{
			//save existing file system
			var oldFileSystem = cfclient.file.getFileSystem();
			
			//Get file object from the path
			var tmpFile = cfclient.file.get(tempFilePath);
			
			//set persistent file system
			var persistentfileSystem = cfclient.file.setFileSystem("persistent");
			
			var newFilePath = persistentfileSystem.root.fullPath + "/" + tmpFile.name;
				
			//If file with the same name exists in the persistent file system, then try save
			//it with different name
			var count = 1;
			while (count < 10)
			{
				try
				{
					cfclient.file.get(newFilePath);
						
					//file already exists. Try different file name
					count++;
					newFilePath = persistentfileSystem.root.fullPath + "/" + replace(tmpFile.name,".","_") + "_" + count + ".jpg";
				} 
				catch (any e) {
					//Assume file does not exists. Go ahead and copy from temp location to persistent location.	
					console.log("Exception : " + e.message);
					break;
				}
			}
			
			//Copy file
			cfclient.file.copy(tempFilePath,newFilePath);
			displayMessage("Image file copied to " + newFilePath + "<br><hr>");
				
			//Restore old file system
			cfclient.file.setFileSystem(oldFileSystem.name);
			
			//return new file path
			return newFilePath;
		}
		
		function uploadFileToServer(imageFilePath)
		{
			if (!structKeyExists(localStorage,"serverUrl"))
			{
				var serverUrl = prompt("Enter Server URL",serverUrl);
				if (serverUrl != null)
					localStorage.serverUrl = serverUrl;
				else
				{
					alert("No file uploaded");
					return;
				}
			}
			
			displayMessage("uploading file to " + localStorage.serverUrl + "<br><hr>");
			
			var uploadOptions = {
				fileKey:"uploadedPicture",
				fileName:"uploadedPictured.jpg"
			};
			
			cfclient.file.upload(imageFilePath, localStorage.serverUrl,
					onFileUploaded, uploadError, uploadOptions
			);
	
			function onFileUploaded()
			{
				displayMessage("File uploaded successfully");
			}
			
			function uploadError(err)
			{
				//See error codes at http://docs.phonegap.com/en/3.3.0/cordova_file_file.md.html#FileTransferError
				if (err.code == 3)
					alert("Error uploading file - Connection error");
				else
					alert("Error uploading file. Code - " + err.code);
			}
			
		}
	</cfscript>
</cfclient>